## qrencode 3.3.1-1maemo1

=== Makefile ===
PACKAGE:=qrencode
VERSION:=3.3.1
SOURCE=qrencode-$(VERSION).tar.gz
URLS=http://fukuchi.org/works/qrencode

include ../Rules.make

## qrencode 3.1.1-1maemo1

=== debian/changelog ===
qrencode (3.1.1-1maemo1) unstable; urgency=low

  * Initial release to Maemo 5.

 -- Daniil Ivanov <daniil.ivanov@gmail.com>  Thu, 25 Mar 2010 14:48:57 +0200

qrencode (3.1.1-1) unstable; urgency=low

  * New upstream release

 -- NIIBE Yutaka <gniibe@fsij.org>  Wed, 03 Feb 2010 15:12:18 +0900

qrencode (3.0.3-1) unstable; urgency=low

  * New upstream release.
  * debian/control (Standards-Version): Conform to 3.8.0.
  (Package): New package, libqrencode3.
  * debian/libqrencode3.{dirs,install}: New files.
  * debian/libqrencode2.{dirs,install}: Removed.
  * debian/{postinst,postrm}: Removed as not used.

 -- NIIBE Yutaka <gniibe@fsij.org>  Tue, 01 Jul 2008 11:53:54 +0900

qrencode (2.0.0-2) unstable; urgency=low

  * debian/control (Build-Depends): Added pkg-config.

 -- NIIBE Yutaka <gniibe@fsij.org>  Mon, 25 Feb 2008 23:22:10 +0900

qrencode (2.0.0-1) unstable; urgency=low

  * Initial release (Closes: #411710).

 -- NIIBE Yutaka <gniibe@fsij.org>  Mon, 18 Feb 2008 17:21:04 +0900

=== debian/control ===
Source: qrencode
Priority: optional
Maintainer: NIIBE Yutaka <gniibe@fsij.org>
Build-Depends: debhelper (>= 5), pkg-config, autotools-dev, libpng12-dev
Standards-Version: 3.8.4
Section: libs
Homepage: http://megaui.net/fukuchi/works/qrencode/index.en.html

Package: qrencode
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: QR Code encoder into PNG image
 Qrencode is a utility software using libqrencode to encode string data in
 a QR Code and save as a PNG image.

Package: libqrencode3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: QR Code encoding library
 Libqrencode is a library for encoding data in a QR Code symbol, a kind of 2D
 symbology that can be scanned by handy terminals such as a mobile phone with
 CCD.  The capacity of QR Code is up to 7000 digits or 4000 characters, and has
 high robustness.
 .
 Libqrencode supports QR Code model 2, described in JIS (Japanese Industrial
 Standards) X0510:2004 or ISO/IEC 18004.

Package: libqrencode-dev
Section: libdevel
Architecture: any
Depends: libqrencode3 (= ${binary:Version}), ${misc:Depends}
Description: QR Code encoding library -- development
 Libqrencode is a library for encoding data in a QR Code symbol, a kind of 2D
 symbology that can be scanned by handy terminals such as a mobile phone with
 CCD.  The capacity of QR Code is up to 7000 digits or 4000 characters, and has
 high robustness.
 .
 Libqrencode supports QR Code model 2, described in JIS (Japanese Industrial
 Standards) X0510:2004 or ISO/IEC 18004.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


# option 2, assuming the library is created as src/.libs/libfoo.so.2.0.5 or so
version=`ls src/.libs/lib*.so.* | \
 awk '{if (match($$0,/[0-9]+\.[0-9]+\.[0-9]+$$/)) print substr($$0,RSTART)}'`
major=`ls src/.libs/lib*.so.* | \
 awk '{if (match($$0,/\.so\.[0-9]+$$/)) print substr($$0,RSTART+4)}'`

config.status: configure
	dh_testdir
	# Add here commands to configure the package.
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs"


build: build-stamp
build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) distclean
	# rm -f config.sub config.guess

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/tmp
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## qrencode 3.3.0

=== debian/changelog ===
qrencode (3.3.0-2) unstable; urgency=low

  * debian/rules: Remove --with quilt.
  * debian/control
    - (Build-Depends): Remove quilt.
  * debian/patches/03_libpthread_handling_fix: Fix to AC_SUBST (was: AC_DEFINE).

 -- NIIBE Yutaka <gniibe@fsij.org>  Mon, 02 Apr 2012 11:58:38 +0900

qrencode (3.3.0-1) unstable; urgency=low

  * New upstream release.
    - debian/patches/series: Disable 00_config_fix and 01_pkg_config_fix.
  * debian/libqrencode3.symbols: Add a symbols file to catch ABI
    change (Closes: #637347).  Thanks to Felix Geyer.
  * debian/control
    - (Build-Depends): Add quilt.
    - qrencode (Description): Add a description for EPS support.
    - libqrencode3 (Section): Remove.
    - libqrencode3 (Description): Add a line to explain this runtime package.
    - libqrencode-dev (Description): Add a line to explain this dev package.
  * debian/rules: Add --with quilt.
  * debian/patches/02_manual_fix: New.  Distinguish hyphen and minus for roff.
  * debian/patches/03_libpthread_handling_fix: New.  Handle -lpthread.

 -- NIIBE Yutaka <gniibe@fsij.org>  Mon, 02 Apr 2012 10:25:18 +0900

qrencode (3.2.0-2) unstable; urgency=low

  * debian/rules: Add --with autoreconf.
  * debian/source/format: New.
  * debian/patches/00_configure_fix: New.  Fix for configure variable
    HAVE_LIBPTHREAD which affects tests/Makefile.
  * debian/patches/01_pkg_config_fix: New. Fix pkg-config file generation
    (Closes: #666247).  Thanks to Jakob Haufe.
  * debian/control (libqrencode3 Multi-Arch): Add.

 -- NIIBE Yutaka <gniibe@fsij.org>  Fri, 30 Mar 2012 11:58:08 +0900

qrencode (3.2.0-1) unstable; urgency=low

  * New upstream release.
    - Linking libpng has been changed (Closes: #641893).
    - '\0' is supported (Closes: #604882).
  * debian/control (Build-Depends): Change libpng-dev (was: libpng12-dev).
    (Closes: #650601).  Thanks to Nobuhiro Iwamatsu.
  * debian/control (Build-Depends): Require debhelper >= 9.
  * debian/compat: Require 9.
  * debian/dirs, debian/libqrencode3.dirs, debian/libqrencode-dev.dirs: Remove.
  * debian/copyright: Write in the format of copyright-format 1.0.
  * debian/rules: as simple as possible.
    (override_dh_auto_configure): Support --with-tests.
    (override_dh_auto_test): Run tests.
    Thanks to Felix Geyer (Closes: #637344).
  * debian/libqrencode3.install, libqrencode-dev.install: Support Multiarch.
  * debian/control (libqrencode3 Pre-Depends): Add multiarch-support.

 -- NIIBE Yutaka <gniibe@fsij.org>  Thu, 29 Mar 2012 14:34:17 +0900

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: qrencode
 Priority: optional
 Maintainer: NIIBE Yutaka <gniibe@fsij.org>
-Build-Depends: debhelper (>= 5), pkg-config, autotools-dev, libpng12-dev
-Standards-Version: 3.8.4
+Build-Depends: debhelper (>= 9), pkg-config, autotools-dev, libpng-dev, libsdl-dev, dh-autoreconf
+Standards-Version: 3.9.3
 Section: libs
 Homepage: http://megaui.net/fukuchi/works/qrencode/index.en.html
 
@@ -12,11 +12,12 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: QR Code encoder into PNG image
  Qrencode is a utility software using libqrencode to encode string data in
- a QR Code and save as a PNG image.
+ a QR Code and save as a PNG or an EPS image.
 
 Package: libqrencode3
-Section: libs
+Multi-Arch: same
 Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: QR Code encoding library
  Libqrencode is a library for encoding data in a QR Code symbol, a kind of 2D
@@ -26,6 +27,8 @@
  .
  Libqrencode supports QR Code model 2, described in JIS (Japanese Industrial
  Standards) X0510:2004 or ISO/IEC 18004.
+ .
+ This package contains runtime libraries of libqrencode.
 
 Package: libqrencode-dev
 Section: libdevel
@@ -39,3 +42,5 @@
  .
  Libqrencode supports QR Code model 2, described in JIS (Japanese Industrial
  Standards) X0510:2004 or ISO/IEC 18004.
+ .
+ This package contains development files (a header, pkg-config settings, etc.)

=== debian/rules ===
#!/usr/bin/make -f
# -*- gmakefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --with-tests

override_dh_autoreconf:
	mkdir m4
	dh_autoreconf

override_dh_autoreconf_clean:
	dh_autoreconf_clean
	rm -rf m4

override_dh_auto_test:
	dh_auto_test
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd tests && ./test_all.sh
endif

## qrencode 3.3.1-1maemo1

=== debian/changelog ===
qrencode (3.3.1-1maemo1) stable; urgency=low

  * New upstream release
  * Bug fixes and new features
  * Experimental Micro QR Code support has been added

 -- Kaj-Michael Lang <milang@tal.org>  Thu, 16 Aug 2012 15:29:00 +0300

=== debian/control ===
Source: qrencode
Priority: optional
Maintainer: Kaj-Michael Lang <milang@tal.org>
Build-Depends: debhelper (>= 5), pkg-config, autotools-dev, libpng12-dev
Standards-Version: 3.8.4
Section: libs
Homepage: http://fukuchi.org/works/qrencode/index.html.en

Package: qrencode
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: QR Code encoder into PNG image
 Qrencode is a utility software using libqrencode to encode string data in
 a QR Code and save as a PNG image.

Package: libqrencode3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: QR Code encoding library
 Libqrencode is a library for encoding data in a QR Code symbol, a kind of 2D
 symbology that can be scanned by handy terminals such as a mobile phone with
 CCD.  The capacity of QR Code is up to 7000 digits or 4000 characters, and has
 high robustness.
 .
 Libqrencode supports QR Code model 2, described in JIS (Japanese Industrial
 Standards) X0510:2004 or ISO/IEC 18004.

Package: libqrencode-dev
Section: libdevel
Architecture: any
Depends: libqrencode3 (= ${binary:Version}), ${misc:Depends}
Description: QR Code encoding library -- development
 Libqrencode is a library for encoding data in a QR Code symbol, a kind of 2D
 symbology that can be scanned by handy terminals such as a mobile phone with
 CCD.  The capacity of QR Code is up to 7000 digits or 4000 characters, and has
 high robustness.
 .
 Libqrencode supports QR Code model 2, described in JIS (Japanese Industrial
 Standards) X0510:2004 or ISO/IEC 18004.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk
# include /usr/share/cdbs/1/rules/simple-patchsys.mk

DEB_DH_INSTALL_SOURCEDIR := debian/tmp

# Use hardware floating point
ifneq (,$(findstring vfp,$(DEB_BUILD_OPTIONS)))
    CFLAGS += -mfpu=vfp -mfloat-abi=softfp
    CXXFLAGS += -mfpu=vfp -mfloat-abi=softfp
endif

DEB_TAR_SRCDIR=qrencode-3.3.1
DEB_CONFIGURE_EXTRA_FLAGS := --enable-static

IS_FREMANTLE=$(shell if grep Fremantle /etc/maemo_version &> /dev/null; then echo y; else echo n; fi)
IS_DIABLO=$(shell if grep Diablo /etc/maemo_version &> /dev/null; then echo y; else echo n; fi)

DEB_DESTDIR=$(CURDIR)/debian/tmp

DEB_OPT_FLAG_armel:=-O2 -fomit-frame-pointer -pipe

ifeq ($(IS_FREMANTLE),y)
DEB_OPT_FLAG_armel:=-O2 -fomit-frame-pointer -pipe -mcpu=cortex-a8 -mfpu=neon -mfloat-abi=softfp
endif

ifeq ($(IS_DIABLO),y)
DEB_OPT_FLAG_armel:=-O2 -fomit-frame-pointer -pipe -mcpu=arm1136jf-s -mfpu=vfp -mfloat-abi=softfp
endif

DEB_OPT_FLAG_i386:=-O2 -fomit-frame-pointer -pipe
DEB_OPT_FLAG:=$(DEB_OPT_FLAG_$(DEB_HOST_ARCH))

include /usr/share/cdbs/1/rules/tarball.mk

## qrencode 3.4.1

=== debian/changelog ===
qrencode (3.4.1-1) unstable; urgency=low

  * New upstream release.
  * debian/rules (DH_OPTIONS): Add.

 -- NIIBE Yutaka <gniibe@fsij.org>  Sat, 24 Nov 2012 14:41:04 +0900

## qrencode 3.4.2

=== debian/changelog ===
qrencode (3.4.2-1) unstable; urgency=low

  * New upstream release.

 -- NIIBE Yutaka <gniibe@fsij.org>  Tue, 09 Jul 2013 07:16:53 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: qrencode
 Priority: optional
-Maintainer: Kaj-Michael Lang <milang@tal.org>
-Build-Depends: debhelper (>= 5), pkg-config, autotools-dev, libpng12-dev
-Standards-Version: 3.8.4
+Maintainer: NIIBE Yutaka <gniibe@fsij.org>
+Build-Depends: debhelper (>= 9), pkg-config, autotools-dev, libpng-dev, libsdl-dev, dh-autoreconf
+Standards-Version: 3.9.4
 Section: libs
-Homepage: http://fukuchi.org/works/qrencode/index.html.en
+Homepage: http://megaui.net/fukuchi/works/qrencode/index.en.html
 
 Package: qrencode
 Section: utils
@@ -12,11 +12,12 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: QR Code encoder into PNG image
  Qrencode is a utility software using libqrencode to encode string data in
- a QR Code and save as a PNG image.
+ a QR Code and save as a PNG or an EPS image.
 
 Package: libqrencode3
-Section: libs
+Multi-Arch: same
 Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: QR Code encoding library
  Libqrencode is a library for encoding data in a QR Code symbol, a kind of 2D
@@ -26,6 +27,8 @@
  .
  Libqrencode supports QR Code model 2, described in JIS (Japanese Industrial
  Standards) X0510:2004 or ISO/IEC 18004.
+ .
+ This package contains runtime libraries of libqrencode.
 
 Package: libqrencode-dev
 Section: libdevel
@@ -39,3 +42,5 @@
  .
  Libqrencode supports QR Code model 2, described in JIS (Japanese Industrial
  Standards) X0510:2004 or ISO/IEC 18004.
+ .
+ This package contains development files (a header, pkg-config settings, etc.)

=== debian/rules ===
#!/usr/bin/make -f
# -*- gmakefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DH_OPTIONS

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --with-tests

override_dh_autoreconf:
	mkdir m4
	dh_autoreconf

override_dh_autoreconf_clean:
	dh_autoreconf_clean
	rm -rf m4

override_dh_auto_test:
	dh_auto_test
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd tests && ./test_all.sh
endif

## qrencode 3.4.3

=== debian/changelog ===
qrencode (3.4.3-1) unstable; urgency=low

  * New upstream release (Closes: 734138).  Thanks to Daniel Baumann
    and Sam Morris.
  * debian/control (Standards-Version): conforms to 3.9.5.

 -- NIIBE Yutaka <gniibe@fsij.org>  Tue, 27 May 2014 13:10:06 +0000

## qrencode 3.4.4

=== debian/changelog ===
qrencode (3.4.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/control (Standards-Version): conforms to 3.9.6.
  * debian/copyright: Fixed list of files.

 -- NIIBE Yutaka <gniibe@fsij.org>  Sat, 19 Dec 2015 08:11:22 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: NIIBE Yutaka <gniibe@fsij.org>
 Build-Depends: debhelper (>= 9), pkg-config, autotools-dev, libpng-dev, libsdl-dev, dh-autoreconf
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Section: libs
 Homepage: http://megaui.net/fukuchi/works/qrencode/index.en.html

=== debian/watch ===
version=3
http://megaui.net/fukuchi/works/qrencode/index.en.html qrencode-([.0-9]*)\.tar\.bz2

## qrencode 4.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(QRencode VERSION 4.0.2 LANGUAGES C)

option(WITH_TOOLS "Build utility tools"  YES )
option(WITH_TESTS "Build tests"  NO )
option(WITHOUT_PNG "Disable PNG support" NO)
option(GPROF "Generate extra code to write profile information" OFF)
option(COVERAGE "Generate extra code to write coverage information" OFF)
option(ASAN "Use AddressSanitizer" OFF)
option(BUILD_SHARED_LIBS "Enable build of shared libraries" NO)

if(BUILD_TESTING)
    set(WITH_TESTS ON)
    message(DEPRECATION "use WITH_TESTS option instead BUILD_TESTING")
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

find_package(Threads)
find_package(PNG)
find_package(Iconv)

## Check for system include files
include(CheckIncludeFile)
include(CheckFunctionExists)

check_include_file(dlfcn.h    HAVE_DLFCN_H   )
check_include_file(inttypes.h HAVE_INTTYPES_H)
check_include_file(memory.h   HAVE_MEMORY_H  )
check_include_file(stdint.h   HAVE_STDINT_H  )
check_include_file(stdlib.h   HAVE_STDLIB_H  )
check_include_file(strings.h  HAVE_STRINGS_H )
check_include_file(string.h   HAVE_STRING_H  )
check_include_file(getopt.h   HAVE_GETOPT_H  )
check_include_file(sys/time.h HAVE_SYS_TIME_H)

check_function_exists(strdup HAVE_STRDUP)

if(HAVE_STRDUP)
    add_definitions(-DHAVE_STRDUP=1)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
endif()

if(GPROF)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pg")
endif()

if(COVERAGE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage")
endif()

if(ASAN)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -fno-omit-frame-pointer -fno-optimize-sibling-calls")
endif()

add_definitions(-DMAJOR_VERSION=${PROJECT_VERSION_MAJOR})
add_definitions(-DMINOR_VERSION=${PROJECT_VERSION_MINOR})
add_definitions(-DMICRO_VERSION=${PROJECT_VERSION_PATCH})
add_definitions(-DVERSION="${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
add_definitions(-DHAVE_SDL=0)

if(MSVC)
    set(CMAKE_DEBUG_POSTFIX "d")

    add_definitions(-Dstrcasecmp=_stricmp)
    add_definitions(-Dstrncasecmp=_strnicmp)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
    
    if(WITH_TOOLS)
        find_path(GETOPT_INCLUDE_DIR getopt.h PATH_SUFFIXES include)
        find_library(GETOPT_LIBRARIES wingetopt PATH_SUFFIXES lib)
        include_directories(${GETOPT_INCLUDE_DIR})
    endif(WITH_TOOLS)
endif(MSVC)

set(QRENCODE_SRCS qrencode.c
                  qrinput.c
                  bitstream.c
                  qrspec.c
                  rsecc.c
                  split.c
                  mask.c
                  mqrspec.c
                  mmask.c)

set(QRENCODE_HDRS qrencode_inner.h
                  qrinput.h
                  bitstream.h
                  qrspec.h
                  rsecc.h
                  split.h
                  mask.h
                  mqrspec.h
                  mmask.h)

if(BUILD_SHARED_LIBS)
    if(MSVC)
        set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
    endif()
    add_library(qrencode SHARED ${QRENCODE_SRCS} ${QRENCODE_HDRS})
    set_target_properties(qrencode PROPERTIES VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH} SOVERSION ${PROJECT_VERSION_MAJOR})
else()
    add_library(qrencode ${QRENCODE_SRCS} ${QRENCODE_HDRS})
endif()

set(prefix "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix "${CMAKE_INSTALL_PREFIX}/bin")
set(libdir "${CMAKE_INSTALL_PREFIX}/lib")
set(includedir "${CMAKE_INSTALL_PREFIX}/include")
set(VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

configure_file(qrencode.1.in qrencode.1 @ONLY)
configure_file(libqrencode.pc.in libqrencode.pc @ONLY)

include(GNUInstallDirs)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qrencode.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libqrencode.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(FILES qrencode.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(TARGETS qrencode DESTINATION ${CMAKE_INSTALL_LIBDIR})

## Build utility tools
if(WITH_TOOLS)
    if(NOT WITHOUT_PNG)
        add_definitions(-DHAVE_PNG=1)
    endif()
    add_executable(qrenc qrenc.c)
    set_target_properties(qrenc PROPERTIES OUTPUT_NAME qrencode)

    target_link_libraries(qrenc qrencode PNG::PNG)

    if(MSVC)
        target_link_libraries(qrenc ${GETOPT_LIBRARIES})
    endif(MSVC)

    install(TARGETS qrenc DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

if(WITH_TESTS)
    enable_testing()
    add_definitions(-DWITH_TESTS=)
    add_definitions(-DSTATIC_IN_RELEASE=)
    add_subdirectory(tests)
else()
    add_definitions(-DSTATIC_IN_RELEASE=static)
endif()

## ==============================================================================
##
##  Configuration summary
##
## ==============================================================================

message(STATUS "------------------------------------------------------------" )
message(STATUS "[QRencode] Configuration summary."                            )
message(STATUS "------------------------------------------------------------ ")
message(STATUS " System configuration:"                                       )
message(STATUS " .. Processor type .............. = ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS " .. CMake executable ............ = ${CMAKE_COMMAND}"         )
message(STATUS " .. CMake version ............... = ${CMAKE_VERSION}"         )
message(STATUS " .. System name ................. = ${CMAKE_SYSTEM}"          )
message(STATUS " .. C++ compiler ................ = ${CMAKE_CXX_COMPILER}"    )
message(STATUS " .. C compiler .................. = ${CMAKE_C_COMPILER}"      )
message(STATUS " .. size(void*) ................. = ${CMAKE_SIZEOF_VOID_P}"   )
message(STATUS " Dependencies:"                                               )
#message(STATUS " .. Doxygen ..................... = ${DOXYGEN_EXECUTABLE}"    )
message(STATUS " .. Thread library of the system  = ${CMAKE_THREAD_LIBS_INIT}")
message(STATUS " .. Iconv ....................... = ${ICONV_FOUND}"           )
message(STATUS " .... Iconv includes ............ = ${ICONV_INCLUDE_DIR}"     )
message(STATUS " .... Iconv library ............. = ${ICONV_LIBRARIES}"       )
message(STATUS " .. ZLIB ........................ = ${ZLIB_FOUND}"            )
message(STATUS " .. PNG ......................... = ${PNG_FOUND}"             )
message(STATUS " .... PNG includes .............. = ${PNG_INCLUDE_DIR}"       )
message(STATUS " .... PNG library ............... = ${PNG_LIBRARIES}"         )
#message(STATUS " .. Memory checker .............. = ${MEMORYCHECK_COMMAND}"   )
message(STATUS " Project configuration:"                                      )
message(STATUS " .. Build test programs  ........ = ${WITH_TESTS}"            )
message(STATUS " .. Build utility tools  ........ = ${WITH_TOOLS}"            )
message(STATUS " .. Disable PNG support  ........ = ${WITHOUT_PNG}"           )
message(STATUS " .. Installation prefix ......... = ${CMAKE_INSTALL_PREFIX}"  )
message(STATUS "------------------------------------------------------------ ")

=== tests/CMakeLists.txt ===
add_library(common
    common.c common.h)
target_link_libraries(common qrencode)

add_library(rscode
    rscode.c rscode.h)
target_link_libraries(rscode common)

macro(MAKE_TEST test_name)
    set(ADDITIONAL_LIBS "${ARGN}")
    add_executable(${test_name} ${test_name}.c)
    target_link_libraries(${test_name} common ${ADDITIONAL_LIBS})
    add_test(${test_name} ${test_name})
endmacro(MAKE_TEST)

if(TARGET PNG::PNG)
    add_executable(create_frame_pattern create_frame_pattern.c)
    target_link_libraries(create_frame_pattern common PNG::PNG)

    add_executable(create_mqr_frame_pattern create_mqr_frame_pattern.c)
    target_link_libraries(create_mqr_frame_pattern common PNG::PNG)
endif()

if(HAVE_SDL)
    add_executable(view_qrcode view_qrcode.c)
    target_link_libraries(view_qrcode common)
endif(HAVE_SDL)

if(TARGET Threads::Threads)
    add_executable(prof_qrencode prof_qrencode.c)
    target_link_libraries(prof_qrencode common Threads::Threads)

    add_executable(pthread_qrencode pthread_qrencode.c)
    target_link_libraries(pthread_qrencode common Threads::Threads)
endif()

MAKE_TEST(test_bitstream)
MAKE_TEST(test_estimatebit)
MAKE_TEST(test_split)

if(TARGET ICONV::ICONV)
    add_library(decoder 
        decoder.c decoder.h 
        datachunk.c datachunk.h 
        rsecc_decoder.c rsecc_decoder.h)
    target_link_libraries(decoder ICONV::ICONV)

    MAKE_TEST(test_qrinput decoder)
    MAKE_TEST(test_qrspec decoder)
    MAKE_TEST(test_mqrspec decoder)
    MAKE_TEST(test_qrencode decoder)
    MAKE_TEST(test_split_urls decoder)
    MAKE_TEST(test_monkey decoder)

    include(CheckCSourceCompiles)
    check_c_source_compiles(
        "int main(){
            const int w = 1;
            char buf[w];
            return 0;
        }"
        FIXED_SIZE_BUFFER_INITIALIZATION)
    
    if(FIXED_SIZE_BUFFER_INITIALIZATION)
        MAKE_TEST(test_mask decoder)
        MAKE_TEST(test_mmask decoder)
        MAKE_TEST(test_rs rscode decoder)
    endif()
endif()

=== debian/changelog ===
qrencode (4.0.2-2) unstable; urgency=medium

  [Ondřej Nový]
  * debian/copyright: Use https protocol in Format field.

  [NIIBE Yutaka]
  * debian/copyright: Update information by new release.
  * debian/control (Standards-Version): Conforms 4.4.1.
    (Multi-Arch): Add "same" for libqrencode-dev.
    Add "foreign" for qrencode (Closes: #941739).
  * debian/patches/0001-use-verbose-configure.patch: New.
  * debian/patches/0002-qrenc-string-boundary.patch: New.

 -- NIIBE Yutaka <gniibe@fsij.org>  Thu, 10 Oct 2019 11:06:36 +0900

qrencode (4.0.2-1) unstable; urgency=medium

  [NIIBE Yutaka]
  * New upstream release (Closes: #900336).
  * debian/rules: Test by test_basic.sh, since the configure test runs
    configure script.
  * Upstream SONAME change.
    - debian/control: Rename to libqrencode4.
    - debian/libqrencode4.install: Rename from debian/libqrencode4.install.
    - debian/libqrencode4.symbols: Rename from debian/libqrencode3.symbols.
  * debian/libqrencode4.symbols: Update.

  [Hideki Yamane]
  * debian/control
    - move Homepage: to new upstream site (Closes: #887144)
    - set Build-Depends: debhelper (>= 11) and drop unnecessary dh-autoreconf
      and autotools-dev
    - add Vcs-*
    - set Standards-Version: 4.1.3
  * debian/rules
    - drop lines related dh-autoreconf sicne it's automatically executed
  * debian/compat
    - set 11
  * debian/watch
    - deal with upstream's change
    - use v4
  * debian/patches
    - drop all files, not used

 -- NIIBE Yutaka <gniibe@fsij.org>  Fri, 07 Sep 2018 16:33:02 +0900

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,15 @@
 Source: qrencode
 Priority: optional
 Maintainer: NIIBE Yutaka <gniibe@fsij.org>
-Build-Depends: debhelper (>= 9), pkg-config, autotools-dev, libpng-dev, libsdl-dev, dh-autoreconf
-Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 11), pkg-config, libpng-dev, libsdl-dev
+Standards-Version: 4.4.1
 Section: libs
-Homepage: http://megaui.net/fukuchi/works/qrencode/index.en.html
+Homepage: https://fukuchi.org/works/qrencode/index.html.en
+Vcs-Git: https://salsa.debian.org/debian/qrencode.git
+Vcs-Browser: https://salsa.debian.org/debian/qrencode
 
 Package: qrencode
+Multi-Arch: foreign
 Section: utils
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -14,7 +17,7 @@
  Qrencode is a utility software using libqrencode to encode string data in
  a QR Code and save as a PNG or an EPS image.
 
-Package: libqrencode3
+Package: libqrencode4
 Multi-Arch: same
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -31,9 +34,10 @@
  This package contains runtime libraries of libqrencode.
 
 Package: libqrencode-dev
+Multi-Arch: same
 Section: libdevel
 Architecture: any
-Depends: libqrencode3 (= ${binary:Version}), ${misc:Depends}
+Depends: libqrencode4 (= ${binary:Version}), ${misc:Depends}
 Description: QR Code encoding library -- development
  Libqrencode is a library for encoding data in a QR Code symbol, a kind of 2D
  symbology that can be scanned by handy terminals such as a mobile phone with

## qrencode 4.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.1.0)
 
-project(QRencode VERSION 4.0.2 LANGUAGES C)
+project(QRencode VERSION 4.1.1 LANGUAGES C)
 
 option(WITH_TOOLS "Build utility tools"  YES )
 option(WITH_TESTS "Build tests"  NO )
@@ -15,11 +15,18 @@
     message(DEPRECATION "use WITH_TESTS option instead BUILD_TESTING")
 endif()
 
-list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
-
+list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+
+set(CMAKE_THREAD_PREFER_PTHREAD ON)
 find_package(Threads)
 find_package(PNG)
 find_package(Iconv)
+
+if(CMAKE_USE_PTHREADS_INIT)
+    add_definitions(-DHAVE_LIBPTHREAD=1)
+    # for libqrencode.pc
+    set(LIBPTHREAD ${CMAKE_THREAD_LIBS_INIT})
+endif()
 
 ## Check for system include files
 include(CheckIncludeFile)
@@ -34,6 +41,8 @@
 check_include_file(string.h   HAVE_STRING_H  )
 check_include_file(getopt.h   HAVE_GETOPT_H  )
 check_include_file(sys/time.h HAVE_SYS_TIME_H)
+check_include_file(time.h     HAVE_TIME_H    )
+check_include_file(pthread.h  HAVE_PTHREAD_H )
 
 check_function_exists(strdup HAVE_STRDUP)
 
@@ -73,7 +82,7 @@
     
     if(WITH_TOOLS)
         find_path(GETOPT_INCLUDE_DIR getopt.h PATH_SUFFIXES include)
-        find_library(GETOPT_LIBRARIES wingetopt PATH_SUFFIXES lib)
+        find_library(GETOPT_LIBRARIES getopt PATH_SUFFIXES lib)
         include_directories(${GETOPT_INCLUDE_DIR})
     endif(WITH_TOOLS)
 endif(MSVC)
@@ -107,17 +116,20 @@
 else()
     add_library(qrencode ${QRENCODE_SRCS} ${QRENCODE_HDRS})
 endif()
-
+if(CMAKE_USE_PTHREADS_INIT)
+    target_link_libraries(qrencode Threads::Threads)
+endif()
+
+include(GNUInstallDirs)
 set(prefix "${CMAKE_INSTALL_PREFIX}")
-set(exec_prefix "${CMAKE_INSTALL_PREFIX}/bin")
-set(libdir "${CMAKE_INSTALL_PREFIX}/lib")
-set(includedir "${CMAKE_INSTALL_PREFIX}/include")
+set(exec_prefix "${CMAKE_INSTALL_FULL_BINDIR}")
+set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
+set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
 set(VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
 configure_file(qrencode.1.in qrencode.1 @ONLY)
 configure_file(libqrencode.pc.in libqrencode.pc @ONLY)
 
-include(GNUInstallDirs)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qrencode.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libqrencode.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 install(FILES qrencode.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
@@ -131,7 +143,11 @@
     add_executable(qrenc qrenc.c)
     set_target_properties(qrenc PROPERTIES OUTPUT_NAME qrencode)
 
-    target_link_libraries(qrenc qrencode PNG::PNG)
+    if(NOT WITHOUT_PNG)
+        target_link_libraries(qrenc qrencode PNG::PNG)
+    else()
+        target_link_libraries(qrenc qrencode)
+    endif()
 
     if(MSVC)
         target_link_libraries(qrenc ${GETOPT_LIBRARIES})

=== debian/changelog ===
qrencode (4.1.1-2) unstable; urgency=medium

  [Niels Thykie]
  * debian/control (Rules-Requires-Root): Don't require root.

  [NIIBE Yutaka]
  * debian/patches/0003-use-tests-cmake.patch: New.
  * debian/patches/series: Update.
  * debian/tests/control: New.
  * debian/tests/build-tests: New.
  * debian/tests/run-tests: New.
  * debian/compat: Remove.
  * debian/control (Build-Depends): Require debhelper-compat = 13.

 -- NIIBE Yutaka <gniibe@fsij.org>  Fri, 29 Nov 2024 16:33:23 +0900

qrencode (4.1.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/0002-qrenc-string-boundary.patch: Update.
  * debian/libqrencode4.symbols: Update.
    (Build-Depends-Package): Add.
  * debian/compat: Upgrade to 13.
  * debian/control (Standards-Version): Conforms to 4.5.1.
    (Build-Depends): Require newer debhelper, change to libsdl2-dev.
    (Rules-Requires-Root): Add.
  * debian/not-installed: New.
  * debian/libqrencode-dev.install: Update.
  * debian/libqrencode4.install: Update.

 -- NIIBE Yutaka <gniibe@fsij.org>  Tue, 22 Dec 2020 14:31:03 +0900

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: qrencode
 Priority: optional
 Maintainer: NIIBE Yutaka <gniibe@fsij.org>
-Build-Depends: debhelper (>= 11), pkg-config, libpng-dev, libsdl-dev
-Standards-Version: 4.4.1
+Build-Depends: debhelper (>= 13~), pkgconf, libpng-dev, libsdl2-dev, debhelper-compat (= 13)
+Standards-Version: 4.5.1
 Section: libs
 Homepage: https://fukuchi.org/works/qrencode/index.html.en
 Vcs-Git: https://salsa.debian.org/debian/qrencode.git
 Vcs-Browser: https://salsa.debian.org/debian/qrencode
+Rules-Requires-Root: no
 
 Package: qrencode
 Multi-Arch: foreign

=== debian/tests/control ===
Tests: build-tests, run-tests
Depends: build-essential, @, cmake, libpng-dev
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://fukuchi.org/works/@PACKAGE@/index.html.en @PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
